function LookupArgsClass() {
	this.items = null;
}



function LookupControlItem(sId, iType, sName, sOnclick, sDisplayClass, sData, sTypeName) {

	this.id = sId;
	this.type = iType;
	this.name = sName;
	this.onclick = sOnclick;
	this.displayClass = sDisplayClass;
	this.data = sData;
	this.typename = sTypeName;
}



function LookupObjects(lookupField, lookupStyle, lookupClass, lookupTypes, lookupBrowse, bindingColumns, additionalParams, showNew, showProp, bPopulateLookup, defaultType)
{
var url;

//Custom Lookup Dialog Start 
var isCustomLookup = false;

if (additionalParams != null) {

	var queryStringArray = additionalParams.split("&");
	var queryStringIndex;

	for(queryStringIndex in queryStringArray) {
		
		var queryString = queryStringArray[queryStringIndex];
		
		if (queryString.length > 18) {		
			if (queryString.toLowerCase().substr(0, 18) == "customlookupclass=") {
				isCustomLookup = true;
				break;
			}
		}
	}
}

if (isCustomLookup) {
	url = "/customLookup/lookupsingle.aspx";
	url += "?class=" + lookupClass;
	
	if (crmForm.ObjectId != null) {
		additionalParams += "&cld_otc=" + crmForm.ObjectTypeCode + "&cld_id=" + crmForm.ObjectId;
	}	
}

else {
	url = "/_controls/lookup/lookup";
	url += lookupStyle;
	url += ".aspx";
	url += "?class=" + lookupClass;
}

url += "&objecttypes=" + lookupTypes;
url += "&browse=" + lookupBrowse;

//Custom Lookup Dialog End

if (bindingColumns)
{
url += "&bindingcolumns=" + encodeURIComponent(bindingColumns);
}

if (additionalParams)
{
if (additionalParams.charAt(0) != "&")
{
url += "&";
}


url += additionalParams;
}

if (showNew)
{
url += "&ShowNewButton=" + showNew;
}

if (showProp)
{
url += "&ShowPropButton=" + showProp;
}

if (!IsNull(defaultType))
{
url += "&DefaultType=" + encodeURIComponent(defaultType);
}

var args = new LookupArgsClass();
if (lookupField != null)
{
args.items = lookupField.getElementsByTagName("SPAN");
}


var oFeatures = BuildFeatures(lookupStyle);

if (oFeatures == null)
return;

var lookupItems = openStdDlg(url, args, oFeatures.width, oFeatures.height, true);

//Custom Lookup Dialog Start
if (isCustomLookup && (lookupItems != null)) {

	var len = lookupItems.items.length;
	for (var i = 0; i < len; ++i) {
		var item = lookupItems.items[i];
		
		if ((item != null) && (item.keyValues != null) && (item.keyValues.data != null)) {			
			item.data = item.keyValues.data.value;
		}
	}
}
//Custom Lookup Dialog End

bPopulateLookup = ("undefined" == typeof(bPopulateLookup)) ? true : bPopulateLookup;

if (lookupItems != null && lookupField != null && bPopulateLookup)
{
BuildField(lookupField, lookupItems);
}

return lookupItems;
}


function BuildFieldSpan(lookupField, lookupItems)
{
var html = "";
var len = lookupItems.items.length;
for (var i = 0; i < len; ++i)
{
var item = lookupItems.items[i];

html += (i > 0 ? " " : "");

var e = parent.document.createElement("SPAN");

e.className	= "lui";
e.oid		= item.id;
e.otype		= item.type;
e.innerHTML	= item.html;
e.onclick	= "openlui();";

html += e.outerHTML;
}
if (html.length == 0)
{
html = "&nbsp;";
}
return html;
}

function BuildField(lookupField, lookupItems)
{
lookupField.innerHTML = BuildFieldSpan(lookupField, lookupItems);
}


function BuildFeatures(lookupStyle)
{
var oFeatures = new Object();

switch (lookupStyle)
{
case "multi":
oFeatures.height = "460px";
oFeatures.width = "600px";
break;
case "single":
oFeatures.height = "488px";
oFeatures.width = "600px";
break;
case "subject":
oFeatures.height = "450px";
oFeatures.width = "500px";
break;
default:
alert(LOCID_LOOKUPSTYLE_NOT_SET + lookupStyle);
return null;
}

return oFeatures;
}

var _iClickTimer;
var _clickedElement;




function handleGridClick()
{

if (_iClickTimer == null)
{

event.cancelBubble	= true;


o = event.srcElement;

while (o.tagName != "SPAN")
{
o = o.parentElement;
}
_clickedElement = o;


var func			= openlui;
_iClickTimer = window.setTimeout(func, 500);
}
}


function clearTimer()
{
window.clearTimeout(_iClickTimer);
_iClickTimer = null;
}


function openDisabledLui()
{

if (event.keyCode == 13 || event.keyCode == 32)
{
openlui(event.srcElement);
}
}



function openlui(o)
{


if (IsNull(event) && IsNull(o))
{

o = _clickedElement;
clearTimer();
}
else if (IsNull(o))
{
o = event.srcElement;

while (o.tagName != "SPAN")
{
o = o.parentElement;
}
}

if (o.otype == UnresolvedAddress)
{
resolveAddress(o.otype, o.oid);
}
else
{
openObj(o.otype, o.oid);
}
}

